<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="编码" prop="alertCode">
        <el-input v-model="formData.alertCode" placeholder="请输入编码" />
      </el-form-item>
      <el-form-item label="名称" prop="alertName">
        <el-input v-model="formData.alertName" placeholder="请输入名称" />
      </el-form-item>
      <el-form-item label="告警类型" prop="alertType">
        <el-select v-model="formData.alertType" placeholder="请选择告警类型">
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.IOT_ALERT_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="告警等级" prop="alertLevel">
        <el-select v-model="formData.alertLevel" placeholder="请输入告警等级">
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.IOT_ALERT_LEVEL)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="告警内容" prop="content">
        <Editor v-model="formData.content" height="150px" />
      </el-form-item>
      <el-form-item label="告警条件" prop="condition">
        <el-input v-model="formData.condition" placeholder="请输入告警条件" />
      </el-form-item>
      <el-form-item label="逻辑表达式" prop="conditionFormula">
        <el-input v-model="formData.conditionFormula" placeholder="请输入逻辑表达式" />
      </el-form-item>
      <el-form-item label="告警音频" prop="alertAudio">
        <el-input v-model="formData.alertAudio" placeholder="请输入告警音频" />
      </el-form-item>
      <el-form-item label="重复告警" prop="isRepeat">
        <el-radio-group v-model="formData.isRepeat">
          <el-radio
            v-for="dict in getBoolDictOptions(DICT_TYPE.INFRA_BOOLEAN_STRING)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="不重复间隔" prop="noRepeatDuration">
        <el-input v-model="formData.noRepeatDuration" placeholder="请输入不重复间隔" />
      </el-form-item>
      <el-form-item label="是否启用" prop="isEnable">
        <el-radio-group v-model="formData.isEnable">
          <el-radio
            v-for="dict in getBoolDictOptions(DICT_TYPE.INFRA_BOOLEAN_STRING)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getStrDictOptions, getBoolDictOptions, DICT_TYPE } from '@/utils/dict'
import { AlertApi, AlertVO } from '@/api/iot/alert'

/** 告警配置 表单 */
defineOptions({ name: 'AlertForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  alertCode: undefined,
  alertName: undefined,
  alertType: undefined,
  alertLevel: undefined,
  content: undefined,
  condition: undefined,
  conditionFormula: undefined,
  alertAudio: undefined,
  isRepeat: undefined,
  noRepeatDuration: undefined,
  isEnable: undefined
})
const formRules = reactive({
  alertCode: [{ required: true, message: '编码不能为空', trigger: 'blur' }],
  alertName: [{ required: true, message: '名称不能为空', trigger: 'blur' }],
  alertAudio: [{ required: true, message: '告警音频不能为空', trigger: 'blur' }],
  isRepeat: [{ required: true, message: '重复告警不能为空', trigger: 'blur' }],
  noRepeatDuration: [{ required: true, message: '不重复间隔不能为空', trigger: 'blur' }],
  isEnable: [{ required: true, message: '是否启用不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await AlertApi.getAlert(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as AlertVO
    if (formType.value === 'create') {
      await AlertApi.createAlert(data)
      message.success(t('common.createSuccess'))
    } else {
      await AlertApi.updateAlert(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    alertCode: undefined,
    alertName: undefined,
    alertType: undefined,
    alertLevel: undefined,
    content: undefined,
    condition: undefined,
    conditionFormula: undefined,
    alertAudio: undefined,
    isRepeat: undefined,
    noRepeatDuration: undefined,
    isEnable: undefined
  }
  formRef.value?.resetFields()
}
</script>
